// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: GaussianIncidentFlux
// Author: Hassan Siddiqui
//
// Description: Abstract class for all Fluxtral shapes
// 
//  
// Modifications: See ChangeLog
// 
// $Id: GaussianIncidentFlux.h,v 1.5 2002/02/12 08:32:19 gvacanti Exp $

#ifndef GAUSSIANINCIDENTFLUX_H
#define GAUSSIANINCIDENTFLUX_H

// General classes

#include <iostream>
#include <cmath>

// SAS-Specific classes

// General utility functions
#include "Tracer.h"

// Local classes
#include "IncidentFlux.h"

class GaussianIncidentFlux: public IncidentFlux
{

public:

  GaussianIncidentFlux(double mean, double standardDeviation): 
    _mean(mean), 
    _standardDeviation(standardDeviation)
    {
    }

  double flux(double energy) const
    {
      PROC;

      double z = (energy - _mean)/_standardDeviation;

      RETURN exp(-0.5 * z * z)/_standardDeviation;

    };

private:

  GaussianIncidentFlux();

  double _mean;
  double _standardDeviation;

};

#endif
