// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: readimage
// Author: Hassan Siddiqui
//
// Description: Reads the output image of dmprmf.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: readimage.cc,v 1.5 2002/02/12 08:32:20 gvacanti Exp $

// General classes
#include <iostream>

// SAS-specific classes
#include "param.h"
#include "Dal.h"
#include "FileLocator.h"

// General utility functions
#include "Tracer.h"

// Utility classes
#include "ImageToColumn.h"

// Local 
#include "readimage.h"

// ---------------------------------------------------

// Main function

// ---------------------------------------------------

void readimage()
{
  PROC;

  // Open file

  DataSet* imageSet = 
    dataSetServer->open(stringParameter("image"), DataSet::Read);

  Array* imageArray = imageSet -> array(stringParameter("image"));


  // Open the output file

  DataSet* outSet = 
    dataSetServer->open(stringParameter("outset"), DataSet::Create);


  // Generate list of desired rows

  vector<string> rowNames = breakup(stringParameter("rows"));


  // Convert into a list of numbers

  vector<unsigned int> rows;

  for (vector<string>::const_iterator i = rowNames.begin();
       i != rowNames.end();
       ++i)
    {
      rows.push_back(atoi((*i).c_str()));
    }


  // Transpose image row(s) to output column.

  ImageToColumn::convert(outSet,
			 imageArray,
			 "IMAGE_DUMP",
			 rows);
  

  // Close datasets

  dataSetServer->close(imageSet);
  dataSetServer->close(outSet);

  ENDPROC;
} 
